コンフィギュレーションパラメータ変更時に個別のパラメータごとにコールバックが呼ばれるようにする
2011/10/10 10:17 - n-ando

ステータス: 終了 開始日: 2011/10/10

優先度: 通常 期日:  

担当者:  進捗率: 100%

カテゴリ:  予定工数: 0.00時間

対象バージョン:    

説明

現在の実装では、onUpdateParamコールバックが呼ばれないが、これを個々のパラメータが変更された際に呼ばれるようにする。
C++ではr2231/2232にてこの変更を行った。
C++における実装方法は以下のとおり。

unbindParameter() の実装 (コールバックとは直接関係ない)
changedParameters() の追加
RTObject::getConfigService() の追加
ConfigBaseにConfigAdminのポインタとメンバー関数ポインタを渡すsetCallback関数を実装
ConfigBaseクラスメンバ変数としてConfigAdminのポインタとメンバー関数ポインタを追加
bindParameter関数内でsetCallbackにてConfigAdminとメンバ関数onUpdateParamを渡す
実際にコールバックを呼ぶConfigBase::nofityUpdateを実装
Configクラスでは、update()関数内で変数の値の変更があった場合にnotifyUpdateを呼ぶ

なお、ConfigAdmin::update()
が呼ばれて初めて変数の値が変更されるため、特に意図的にコールしなければこのコールバックはRTCがactive状態の時にのみコー
ルされる。

関係しているリビジョン
リビジョン 631 - 2012/01/11 10:52 - fsi-katami

The callback of the configuration is added. refs #2267

リビジョン 632 - 2012/01/11 11:01 - fsi-katami

The callback of the configuration is added. refs #2267

リビジョン 634 - 2012/01/12 11:52 - fsi-katami

ConfigAdmin::changedParameters() has been added. RTObject::getConfigService() has been added. refs #2267

リビジョン 635 - 2012/01/12 14:53 - fsi-katami

Clear changed parameterlist in update() functions. refs #2267

リビジョン 636 - 2012/01/12 15:04 - fsi-katami

The callback of the configuration is added. refs #2267

リビジョン 637 - 2012/01/12 15:20 - fsi-katami

Update on initialize has been added. refs #2267

履歴
#1 - 2011/10/10 10:18 - n-ando

- プロジェクト を OpenRTM-aist (Python) から OpenRTM-aist (Java) に変更

#2 - 2011/10/11 01:19 - n-ando

- 説明 を更新

#3 - 2012/01/12 15:21 - 匿名ユーザー

- ステータス を 新規 から 解決 に変更

- 進捗率 を 0 から 100 に変更

2025/05/21 1/2



#4 - 2012/02/04 04:10 - n-ando

- ステータス を 解決 から 終了 に変更
